package
{
	import com.bit101.components.CheckBox;
	import com.bit101.components.HSlider;
	import com.bit101.components.Label;
	import com.bit101.components.PushButton;
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.geom.Rectangle;
	import flash.ui.Keyboard;
	
	import it.sephiroth.ui.components.DistortTool;

	[SWF(frameRate="60", backgroundColor="0")]
	public class test_distort extends Sprite
	{
		private var bmp: Bitmap;

		private var distort: DistortTool;
		private var start_distort: PushButton;
		private var end_distort: PushButton;
		private var segments_label: Label;
		private var segments_slider: HSlider;
		private var overlay_checkbox: CheckBox;
		private var restore_button: PushButton;
		private var _original: BitmapData;

		[Embed( source="assets/image2.jpg" )]
		private var img: Class;
		
		public function test_distort()
		{
			super();
			addEventListener( Event.ADDED_TO_STAGE, onAddedToStage );
		}

		private function onAddedToStage( event: Event ): void
		{
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
			start_distort = new PushButton( this, 10, 10, "Start Distort", onStartClick );
			end_distort = new PushButton( this, start_distort.x + start_distort.width + 10, 10, "End Distort", onEndClick );
			restore_button = new PushButton( this, end_distort.x + end_distort.width + 10, 10, "Restore", onRestoreClick );
			
			segments_slider = new HSlider( this, 10, 40, onSliderChange );
			segments_slider.minimum = 1;
			segments_slider.maximum = 60;
			segments_slider.value = 20;
			
			segments_label = new Label( this, segments_slider.x + segments_slider.width + 10, 35, "Segments: " + segments_slider.value );
			end_distort.alpha = 0.5;
			
			overlay_checkbox = new CheckBox( this, 10, 60, "Display Points", onOverlayChange );
			
			
			bmp = new img();
			bmp.x = 50;
			bmp.y = 120;
			addChild( bmp );
			
			_original = bmp.bitmapData.clone();
		}
		
		private function onOverlayChange( event: Event ): void
		{
			if( distort != null )
			{
				distort.displayPoints = overlay_checkbox.selected;
			}
		}
		
		private function onSliderChange( event: Event ): void
		{
			segments_label.text = "Segments: " + int(segments_slider.value);
			if( distort )
				distort.segments = int(segments_slider.value);
		}
		
		private function onStartClick( event: Event ): void
		{
			init_distort();
		}
		
		private function onEndClick( event: Event ): void
		{
			complete_distort();
		}
		
		private function onRestoreClick( event: Event ): void
		{
			restore_distort();
		}
		
		private function restore_distort(): void
		{
			if( distort )
			{
				removeChild( distort );
				distort = null;
			}
				
			start_distort.alpha = 1;
			end_distort.mouseEnabled = false;
			end_distort.alpha = 0.5;
				
			setBitmapData( _original.clone() );
			bmp.visible = true;
			bmp.x = 50;
			bmp.y = 120;
		}
		
		private function setBitmapData( value: BitmapData ): void
		{
			bmp.bitmapData = value;
		}
		
		private function init_distort(): void
		{
			if( distort == null )
			{
				start_distort.alpha = 0.5;
				end_distort.alpha = 1;
				
				distort = new DistortTool( int(segments_slider.value) );
				distort.displayPoints = overlay_checkbox.selected;
				distort.target = bmp;
				
				bmp.visible = false;
				distort.transform.matrix = bmp.transform.matrix;
				
				addChild( distort );
			}
		}
		
		private function complete_distort(): void
		{
			if( distort != null )
			{
				start_distort.alpha = 1;
				end_distort.mouseEnabled = false;
				end_distort.alpha = 0.5;
				
				var bounds: Rectangle = distort.outputBounds;
				var result: BitmapData = new BitmapData( bounds.width, bounds.height, true, 0 );
				
				result.draw( distort.outputDisplay, new Matrix( 1, 0, 0, 1, -bounds.x, -bounds.y ) );
				
				setBitmapData( result );
				
				bmp.visible = true;
				
				var matrix: Matrix = bmp.transform.matrix.clone();
				matrix.concat( new Matrix( 1, 0, 0, 1, bounds.x, bounds.y ) );
				
				bmp.transform.matrix = matrix;
				
				removeChild( distort );
				distort = null;
				
			}
		}
	}
}